C     FINITE ELEMENT METHOD  ------- F3D6000.FOR ------                 
C         FOR THREE DIMENSIONAL ELASTIC ANALYSIS                        
C       BY TAKAYUKI HIRAI & TOSHIO TERASAKI 1997/7                   
C      
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(20),H22(3,20),XYZ(3,20),DET,GZ,EA,
     1          ZE,H(3,20,5,5,5),BMA(6,60),M,LX,LY,LZ,IRR
      COMMON /B/RN(20,5,5,5),DB(6,60),EE(6,6,500),XGX(5),               
     1          WGX(5),GX(30000),TTA(60),TTB(60),MC(21)                 
      COMMON /C/LC(18000),JD(18000),B(18000),F(18000),                  
     1          JU2(18000),JU3(18000),KPC(18000),                       
     2          LTS(18000),JSC(18000),TTT(18000)                        
      COMMON /D/KPA(18000),LTP(18000),JP2(18000),JP3(18000)                 
      COMMON /E/KNB(18000),KNC(18000),IDI(18000),                       
     1          DU(3,8000),NCB(3,8000),KNA(18000)                     
      COMMON /F/STI(2000),MVE(21,2000),EM(500),PR(500)                  
      COMMON /G/STW(30000000)                                            
      COMMON /H/STWT(30000000)                                           
      COMMON /I/STF(20000000)                                            
      CHARACTER TITLE*5                                                
C                                                                       
C  ------------------  INPUT DATA  --------------------                 
      KNELE=2000
      KNMAT=500                                                         
      KNODE=6000                                                  
      LVOL=30000000                                                      
      LBOL=20000000                                                    
      IRR=0                                                             
      OPEN(05,FILE='DD',STATUS='OLD')                           
      OPEN(06,FILE='R1')                                        
      CLOSE(06,STATUS='DELETE')
      OPEN(06,FILE='R1')                                        
      READ(05,1001) TITLE                                               
      WRITE(06,2002) TITLE                                              
      READ(05,1002) NELE,NODE,NMAT,NGA                                  
      WRITE(06,2003) NELE,NODE,NMAT,NGA                                 
      WRITE(00,2101) TITLE                                     
      WRITE(00,2102) NELE,NODE
      IF(NELE*(KNELE-NELE+1).LE.0) IRR=11000                            
      IF(NODE*(KNODE-NODE+1).LE.0) IRR=12000                            
      IF(NMAT*(KNMAT-NMAT+1).LE.0) IRR=13000                            
      IF((NGA-2)*(6-NGA).LE.0.0) IRR=14000                              
      IF(IRR.NE.0) GO TO 403                                            
      NODE3=3*NODE                                                      
      WRITE(06,2005)                                                    
      DO 10 I=1,NODE                                                    
      DO 11 J=1,3                                                       
      NCB(J,I)=0                                                        
      F(J+I*3-3)=0.0                                                    
   11 DU(J,I)=0.0                                                       
      READ(05,1003) NS,B(I*3-2),B(I*3-1),B(I*3)                         
   10 WRITE(06,2004) I,B(I*3-2),B(I*3-1),B(I*3)                         
      DO 15 J=1,NELE                                                    
      READ(05,1005) MS,(MVE(I,J),I=1,21),STI(J)                         
      DO 19 I=1,20                                                      
      IF(I.EQ.20) GO TO 19                                              
      I3=I+1                                                            
      DO 14 K=I3,20                                                     
   14 IF(MVE(I,J).EQ.MVE(K,J)) IRR=20000+J                              
   19 IF(MVE(I,J)*(NODE-MVE(I,J)+1).LE.0) IRR=30000+J                   
   15 IF(MVE(21,J)*(NMAT-MVE(21,J)+1).LE.0) IRR=35000+J                 
      IF(IRR.NE.0) GO TO 403                                            
      WRITE(06,2008)                                                    
      DO 16 J=1,NMAT                                                    
      READ(05,1006) ID,EM(J),PR(J)                                      
      WRITE(06,2009)ID,EM(J),PR(J)                                      
      IF(EM(J).LE.1.0) IRR=50000+J                                      
      IF(PR(J)*(0.4999-PR(J)).LT.0) IRR=55000+J                         
      IF(IRR.NE.0) GO TO 403                                            
      DO 17 II=1,6                                                      
      DO 17 JK=1,6                                                      
   17 EE(II,JK,J)=0.0                                                   
      EE(6,6,J)=EM(J)/(1.0+PR(J))                                       
      EE(1,1,J)=EE(6,6,J)*(1.0-PR(J))/(1.0-2.0*PR(J))                   
      EE(1,2,J)=EE(6,6,J)*PR(J)/(1.0-2.0*PR(J))                         
      EE(6,6,J)=0.5*EE(6,6,J)                                           
      EE(5,5,J)=EE(6,6,J)                                               
      EE(4,4,J)=EE(6,6,J)                                               
      DO 16 I=1,3                                                       
      DO 16 K=1,3                                                       
      IF(I.EQ.K) EE(I,K,J)=EE(1,1,J)                                    
   16 IF(I.NE.K) EE(I,K,J)=EE(1,2,J)                                    
      JBO=0                                                             
   13 READ(05,1004,END=12) J,N1,N2,N3,X1,X2,X3
      IF(J.EQ.99999) GOTO 18                          
      IF(J*(NODE-J+1).LE.0) IRR=69500                   
      JBO=JBO+1                                                         
      KPC(JBO)=J                                                        
      NCB(1,J)=N1                                                       
      NCB(2,J)=N2                                                       
      NCB(3,J)=N3                                                       
      IF(N1.EQ.0) F(3*J-2)=X1                                           
      IF(N2.EQ.0) F(3*J-1)=X2                                           
      IF(N3.EQ.0) F(3*J)=X3                                             
      IF(N1.NE.0) DU(1,J)=X1                                            
      IF(N2.NE.0) DU(2,J)=X2                                            
      IF(N3.NE.0) DU(3,J)=X3                                            
      IF((N1+1)*(2-N1).LE.0) IRR=60000+J                                
      IF((N2+1)*(2-N2).LE.0) IRR=60000+J                                
      IF((N3+1)*(2-N3).LE.0) IRR=60000+J                                
      GO TO 13                                                          
   12 CONTINUE
   18 IF(JBO.LT.3) IRR=69000                                            
      IF(IRR.NE.0) GO TO 403                                            
 1001 FORMAT(A5)                                                        
 1002 FORMAT(4I5)                                                       
 1003 FORMAT(I5,3F15.6)                                                 
 1004 FORMAT(4I5,3F15.6)                                                
 1005 FORMAT(11I4/I8,10I4,F10.7)                                        
 1006 FORMAT(I5,2F15.6)                                                 
 2002 FORMAT(//' ',10X,'FINITE ELEMENT METHOD USING ',                  
     1   '20 NODE HEXAHEDRON ELEMENT FOR 3 DIMENSION',                  
     2   'AL ELASTIC ANALYSIS'/' ',10X,'------ F3D60',                  
     3   '00(1997/7) ------     BY TAKAYUKI HIRAI & ',                  
     4   'TOSHIO TERASAKI'//'  MODEL TITLE    = ',A5)                   
 2003 FORMAT(//'  ELEMENTS =',I5,'     TOTAL NODES =',                  
     1   I5,'     MATERIALS =',I3,'     GAUSS POINTS',                  
     2   ' =',I3)                                                       
 2004 FORMAT(I5,3F15.6)                                                 
 2005 FORMAT(/' NODE',11X,'X',13X,'Y',13X,'Z')                          
 2008 FORMAT(/' MATERIAL NO.   YOUNG''S RATIO  ',                       
     1   '     POISSON''S RATIO')                                       
 2009 FORMAT(I9,5X,2F15.6)                                              
 2101 FORMAT(/' START     TITLE= ',A40)
 2102 FORMAT(/'           ELEMENT=',I5,'    NODE=',I5) 
C                                                                       
C  ------------  FORM CONECTION TABLE  ----------------                 
      IDI(1)=1                                                          
      I2=1                                                              
      DO 102 J=1,NODE                                                   
      I3=NODE                                                           
      DO 101 M=1,NELE                                                   
      DO 104 I=1,20                                                     
  104 IF(IDI(J).EQ.MVE(I,M)) GO TO 106                                  
      GO TO 101                                                         
  106 DO 107 I=1,20                                                     
      DO 105 K=1,I2                                                     
  105 IF(IDI(K).EQ.MVE(I,M)) GO TO 115                                  
      I2=I2+1                                                           
      IDI(I2)=MVE(I,M)                                                  
      GO TO 107                                                         
  115 IF(K.LT.I3) I3=K                                                  
  107 CONTINUE                                                          
  101 CONTINUE                                                          
      KNB(J)=I2                                                         
      KNA(J)=I3                                                         
  102 CONTINUE                                                          
      DO 108 I=2,NODE                                                   
      II=I                                                              
      DO 108 J=II,NODE                                                  
  108 IF(IDI(I-1).EQ.IDI(J)) IRR=71000                                  
      IF(I2.NE.NODE) IRR=71000                                          
      KNC(1)=KNB(1)                                                     
      DO 112 I=2,NODE                                                   
      KNC(I)=KNB(I)-KNA(I)+1                                            
      IF(KNA(I).GT.I) IRR=71000                                         
      IF(KNB(I).LT.I) IRR=71000                                         
      IF(KNA(I).LT.KNA(I-1)) IRR=71000                                  
  112 IF(KNB(I).LT.KNB(I-1)) IRR=71000                                  
      DO 121 I=1,NODE                                                   
      DO 121 J=1,3                                                      
      I3=I*3-3+J                                                        
      JSC(I3)=(KNB(I)-I)*3+4-J                                          
      IF(I3.EQ.1) LTS(1)=JSC(1)                                         
  121 IF(I3.GT.1) LTS(I3)=LTS(I3-1)+JSC(I3)                             
      LTSN=LTS(NODE3)                                                   
      IF(LTSN.GT.LVOL)IRR=72000                                         
      IF(IRR.NE.0) GO TO 403                                            
C                                                                       
C  ----------  CALCULATE STIFFNESS MATRIX  ------------                 
      WRITE(00,2103)
 2103 FORMAT(/'        CALCULATING STIFFNESS MATRIX')     
      DO 250 I=1,NODE3                                                  
  250 TTT(I)=0.0                                                        
      IF(NGA.EQ.4) GO TO 222                                            
      IF(NGA.EQ.5) GO TO 223                                            
      XGX(1)=-0.7745967                                                 
      XGX(2)=0.0                                                        
      XGX(3)=-XGX(1)                                                    
      WGX(1)=0.5555556                                                  
      WGX(2)=0.8888889                                                  
      WGX(3)=WGX(1)                                                     
      GO TO 224                                                         
  222 XGX(1)=-0.8611363                                                 
      XGX(2)=-0.3399810                                                 
      XGX(3)=-XGX(2)                                                    
      XGX(4)=-XGX(1)                                                    
      WGX(1)=0.3478548                                                  
      WGX(2)=0.6521452                                                  
      WGX(3)=WGX(2)                                                     
      WGX(4)=WGX(1)                                                     
      GO TO 224                                                         
  223 XGX(1)=-0.9061798                                                 
      XGX(2)=-0.5384693                                                 
      XGX(3)=0.0                                                        
      XGX(4)=-XGX(2)                                                    
      XGX(5)=-XGX(1)                                                    
      WGX(1)=0.2369269                                                  
      WGX(2)=0.4786287                                                  
      WGX(3)=0.5688889                                                  
      WGX(4)=WGX(2)                                                     
      WGX(5)=WGX(1)                                                     
  224 DO 202 LX=1,NGA                                                   
      GZ=XGX(LX)                                                        
      DO 202 LY=1,NGA                                                   
      EA=XGX(LY)                                                        
      DO 202 LZ=1,NGA                                                   
      ZE=XGX(LZ)                                                        
      WT=WGX(LX)*WGX(LY)*WGX(LZ)                                        
      CALL GGG                                                          
      DO 202 II=1,20                                                    
      RN(II,LX,LY,LZ)=RN22(II)                                          
      DO 202 JJ=1,3                                                     
  202 H(JJ,II,LX,LY,LZ)=H22(JJ,II)                                      
      WRITE(06,2202)                                                    
      L2=LTS(NODE3)                                                     
      DO 234 L=1,L2                                                     
  234 STW(L)=0.0                                                        
      DO 211 M=1,NELE                                                   
      SVOL=0.0                                                          
      DO 212 II=1,20                                                    
      MC(II)=MVE(II,M)                                                  
      DO 212 JJ=1,3                                                     
  212 XYZ(JJ,II)=B(MC(II)*3-3+JJ)                                       
      MC(21)=MVE(21,M)                                                  
      DO 215 I=1,3600                                                   
  215 GX(I)=0.0                                                         
      DO 216 LX=1,NGA                                                   
      GZ=XGX(LX)                                                        
      DO 216 LY=1,NGA                                                   
      EA=XGX(LY)                                                        
      DO 216 LZ=1,NGA                                                   
      ZE=XGX(LZ)                                                        
      WT=WGX(LX)*WGX(LY)*WGX(LZ)                                        
      CALL FFF                                                          
      IF(IRR.NE.0) GO TO 403                                            
      DO 217 I=1,6                                                      
      DO 217 J=1,60                                                     
      DB(I,J)=0.0                                                       
      DO 217 K=1,6                                                      
  217 DB(I,J)=DB(I,J)+EE(I,K,MC(21))*BMA(K,J)                           
      VOL=WT*DET                                                        
      DO 218 I=1,60                                                     
      DO 218 J=1,60                                                     
      DO 218 K=1,6                                                      
  218 GX(I*60-60+J)=GX(I*60-60+J)+BMA(K,I)*DB(K,J)*VOL                  
  216 SVOL=SVOL+VOL                                                     
      IF(SVOL.LE.0.0) IRR=45000+M                                       
      IF(IRR.NE.0) GO TO 403                                            
      WRITE(06,2203) M,(MVE(I7,M),I7=1,21),STI(M),SVOL                  
      DO 208 I=1,20                                                     
      DO 208 J=1,3                                                      
  208 TTA(I*3-3+J)=XYZ(J,I)*STI(M)                                      
      DO 209 I=1,60                                                     
      TTB(I)=0.0                                                        
      DO 209 J=1,60                                                     
  209 TTB(I)=TTB(I)+GX(I*60-60+J)*TTA(J)                                
      DO 210 I=1,20                                                     
      DO 213 J=1,NODE                                                   
  213 IF(J.EQ.MVE(I,M)) GO TO 214                                       
  214 DO 219 K=1,3                                                      
      TTT(J*3-3+K)=TTT(J*3-3+K)+TTB(I*3-3+K)                            
  219 F(J*3-3+K)=F(J*3-3+K)+TTB(I*3-3+K)                                
  210 CONTINUE                                                          
      DO 231 I=1,20                                                     
      DO 232 L=1,NODE                                                   
  232 IF(IDI(L).EQ.MVE(I,M)) GO TO 235                                  
      IRR=30000+M                                                       
      GO TO 403                                                         
  235 KB=KNB(L)                                                         
      DO 231 J=1,20                                                     
      DO 236 K=L,KB                                                     
  236 IF(MVE(J,M).EQ.IDI(K)) GO TO 237                                  
      GO TO 231                                                         
  237 L3=L*3                                                            
      I3=I*3                                                            
      J3=J*3                                                            
      IF(K.EQ.L) GO TO 238                                              
      DO 233 II=1,3                                                     
      DO 233 JJ=1,3                                                     
  233 STW(LTS(L3-3+II)-(KB-K+1)*3+JJ)=STW(LTS(L3-3+II)                  
     1   -(KB-K+1)*3+JJ)+GX((I3-4+II)*60+J3-3+JJ)                       
      GO TO 231                                                         
  238 STW(LTS(L3-2)-JSC(L3-2)+1)=STW(LTS(L3-2)-                         
     1   JSC(L3-2)+1)+GX((I3-3)*60+J3-2)                                
      STW(LTS(L3-2)-JSC(L3-2)+2)=STW(LTS(L3-2)-                         
     1   JSC(L3-2)+2)+GX((I3-3)*60+J3-1)                                
      STW(LTS(L3-2)-JSC(L3-2)+3)=STW(LTS(L3-2)-                         
     1   JSC(L3-2)+3)+GX((I3-3)*60+J3)                                  
      STW(LTS(L3-1)-JSC(L3-1)+1)=STW(LTS(L3-1)-                         
     1   JSC(L3-1)+1)+GX((I3-2)*60+J3-1)                                
      STW(LTS(L3-1)-JSC(L3-1)+2)=STW(LTS(L3-1)-                         
     1   JSC(L3-1)+2)+GX((I3-2)*60+J3)                                  
      STW(LTS(L3)-JSC(L3)+1)=STW(LTS(L3)-                               
     1   JSC(L3)+1)+GX(I3*60-60+J3)                                     
  231 CONTINUE                                                          
  211 CONTINUE                                                          
 2202 FORMAT(/' ELEMENT   NODE NO.',66X,'MATERIAL   INI'                
     1   ,'.STRAIN   VOLUME'/' NO.     1   -   -   -   '                
     2   ,'5   -   -   -   -  10   -   -   -   -  15   '                
     3   ,'-   -   -   -  20')                                          
 2203 FORMAT(I4,I6,19I4,I5,F12.7,F12.4)                                 
C                                                                       
C  ----------  FORM SIMULTANEOUS EQUATIONS  -----------                 
      WRITE(00,2104)
 2104 FORMAT(/'        SOLVING SIMULTANEOUS EQUATIONS')
      J5=0                                                              
      J9=0                                                              
      J88=0                                                             
      J66=0                                                             
      DO 301 I2=1,NODE                                                  
      KA=KNA(I2)                                                        
      KB=KNB(I2)                                                        
      DO 301 I3=1,3                                                     
      IF(NCB(I3,IDI(I2)).EQ.1) GO TO 302                                
      J9=J9+1                                                           
      J8=0                                                              
      B(J9)=F(IDI(I2)*3-3+I3)                                           
      JU2(J9)=IDI(I2)                                                   
      JU3(J9)=I3                                                        
      DO 303 I4=KA,KB                                                   
      DO 303 I5=1,3                                                     
      IF(NCB(I5,IDI(I4)).EQ.1) GO TO 304                                
      IF(I4*3+I5.LT.I2*3+I3) GO TO 303                                  
      J8=J8+1                                                           
      GX(J8)=STW(LTS(I2*3-3+I3)-JSC(I2*3-3+I3)                          
     1   +(I4-I2)*3+I5-I3+1)                                            
      GO TO 303                                                         
  304 L6=LTS(I2*3-3+I3)-JSC(I2*3-3+I3)                                  
     1   +(I4-I2)*3+I5-I3+1                                             
      IF(I4*3+I5.LT.I2*3+I3) L6=LTS(I4*3-3+I5)-                         
     1   JSC(I4*3-3+I5)+(I2-I4)*3+I3-I5+1                               
      B(J9)=B(J9)-DU(I5,IDI(I4))*STW(L6)                                
  303 CONTINUE                                                          
      IF(J88.LT.J8) J88=J8                                              
      JD(J9)=J8                                                         
      IF(J9.EQ.1) LC(J9)=J8                                             
      IF(J9.GT.1) LC(J9)=LC(J9-1)+J8                                    
      L1=1                                                              
      IF(J9.GT.1) L1=LC(J9-1)+1                                         
      L2=LC(J9)                                                         
      DO 311 LL=L1,L2                                                   
  311 STWT(LL)=GX(LL-L1+1)                                              
      GO TO 301                                                         
  302 J5=J5+1                                                           
      J6=0                                                              
      JP2(J5)=IDI(I2)                                                   
      JP3(J5)=I3                                                        
      DO 305 I4=KA,KB                                                   
      DO 305 I5=1,3                                                     
      J6=J6+1                                                           
      L6=LTS(I2*3-3+I3)-JSC(I2*3-3+I3)                                  
     1   +(I4-I2)*3+I5-I3+1                                             
      IF(I4*3+I5.LT.I2*3+I3) L6=LTS(I4*3-3+I5)-                         
     1   JSC(I4*3-3+I5)+(I2-I4)*3+I3-I5+1                               
  305 GX(J6)=STW(L6)                                                    
      IF(J66.LT.J6) J66=J6                                              
      IF(J5.EQ.1) LTP(J5)=J6                                            
      IF(J5.GT.1) LTP(J5)=LTP(J5-1)+J6                                  
      KPA(J5)=KNA(I2)                                                   
      KPC(J5)=KNC(I2)                                                   
      L1=1                                                              
      IF(J5.GT.1) L1=LTP(J5-1)+1                                        
      L2=LTP(J5)                                                        
      DO 312 LL=L1,L2                                                   
  312 STF(LL)=GX(LL-L1+1)                                               
  301 CONTINUE                                                          
      LCOT=LC(J9)                                                       
      BMX=0.0                                                           
      DO 306 I=1,J9                                                     
      GX(I)=B(I)                                                        
      IF(ABS(GX(I)).GT.BMX) BMX=ABS(GX(I))                              
  306 IF(JD(I).GT.J9-I+1) IRR=71000                                     
      IF(LCOT.GT.LVOL) IRR=72000
C      IF(J5.GT.KJBO*2) IRR=73000                                        
      IF(J9+J5.NE.NODE3) IRR=71000                                      
      IF(J88.GT.NODE3) IRR=71000                                        
      IF(J66.GT.NODE3) IRR=71000                                        
      IF(LTP(J5).GT.LBOL) IRR=73000                                     
C                                                                       
C  ---------  SOLVE SIMULTANEOUS EQUATIONS  -----------                 
      L1=LC(J9)                                                         
      DO 313 LL=1,L1                                                    
  313 STW(LL)=STWT(LL)                                                  
      I2=LC(1)                                                          
      DO 361 I=1,I2                                                     
  361 JSC(I)=1                                                          
      DO 362 I=2,J9                                                     
      I2=I+JD(I-1)-1                                                    
      I3=I+JD(I)-1                                                      
      IF(I3.LT.I2-1) IRR=71000                                          
      IF(IRR.NE.0) GO TO 403                                            
      IF(I3.EQ.I2-1) GO TO 362                                          
      DO 363 J=I2,I3                                                    
  363 JSC(J)=I                                                          
  362 CONTINUE                                                          
      IF(ABS(STW(1)).LT.0.000001) IRR=75000                             
      IF(IRR.NE.0) GO TO 403                                            
      DO 351 I=2,J9                                                     
      WRITE(00,2105) I,J9                            
 2105 FORMAT(1H ,' SOLVING SIMULTANEOUS EQUATIONS NO.=',I6,' /',I6)     
      LA=LC(I-1)+1                                                      
      LB=LC(I)                                                          
      IM=I-1                                                            
      IF(ABS(STW(LA)).LT.0.000001) IRR=75000                            
      IF(IRR.NE.0) GO TO 403                                            
      DO 351 L=LA,LB                                                    
      KC=JSC(I+L-LA)                                                    
      DO 351 K=KC,IM                                                    
      L3=LC(K-1)+1                                                      
      L1=L3+I-K                                                         
      L2=L1+L-LA                                                        
  351 STW(L)=STW(L)-STW(L1)*STW(L2)/STW(L3)                             
      B(1)=B(1)/STW(1)                                                  
      DO 371 I=2,J9                                                     
      I2=JSC(I)                                                         
      I3=I-1                                                            
      IF(I2.GT.I3) GO TO 371                                            
      DO 372 J=I2,I3                                                    
  372 B(I)=B(I)-B(J)*STW(LC(J)-JD(J)+I-J+1)                             
  371 B(I)=B(I)/STW(LC(I)-JD(I)+1)                                      
      I2=J9-1                                                           
      DO 373 I=1,I2                                                     
  373 B(I)=B(I)*STW(LC(I)-JD(I)+1)                                      
      DO 375 I=1,I2                                                     
      I3=J9-I                                                           
      L4=LC(I3)-JD(I3)+2                                                
      L5=LC(I3)                                                         
      IF(L4.GT.L5) GO TO 375                                            
      DO 376 L=L4,L5                                                    
  376 B(I3)=B(I3)-STW(L)*B(I3+L-L4+1)                                   
  375 B(I3)=B(I3)/STW(L4-1)                                             
C                                                                       
C  --------------  CALCULATE SOLUTION  ----------------                 
      BW=0.0                                                            
      DO 384 I=1,J9                                                     
      I4=JU2(I)*3-3+JU3(I)                                              
      I2=JSC(I)                                                         
      FBR=0.0                                                           
      I3=I-1                                                            
      DO 385 J=I2,I3                                                    
  385 FBR=FBR+STWT(LC(J)-JD(J)+I-J+1)*B(J)                              
      I2=I+JD(I)-1                                                      
      DO 386 J=I,I2                                                     
  386 FBR=FBR+STWT(LC(I)-JD(I)+J-I+1)*B(J)                              
      IF(ABS(FBR-GX(I)).LE.BW) GO TO 384                                
      IW=I                                                              
      BW=ABS(FBR-GX(I))                                                 
  384 F(I4)=F(I4)+FBR-GX(I)
      IF (BMX.LT.0.000001) GO TO 382
      BWW=BW/BMX                                                        
      GO TO 388
  382 BWW=999999.9
      IRR=69000
  388 DO 381 I=1,J9                                                     
      I2=JU2(I)                                                         
      I3=JU3(I)                                                         
  381 DU(I3,I2)=B(I)                                                    
      DO 383 I=1,J5                                                     
      I2=JP2(I)*3-3+JP3(I)                                              
      F(I2)=0.0                                                         
      I4=KPA(I)                                                         
      I5=I4+KPC(I)-1                                                    
      DO 383 J=I4,I5                                                    
      DO 383 K=1,3                                                      
  383 F(I2)=F(I2)+STF(LTP(I)+(J-I4-KPC(I))*3+K)                         
     1   *DU(K,IDI(J))                                                  
      DO 390 I=1,NODE3                                                  
  390 F(I)=F(I)-TTT(I)                                                  
C                                                                       
C  ---------------  OUTPUT SOLUTION  -----------------                  
      WRITE(06,2404)
      XM1=0.0
      YM1=0.0
      ZM1=0.0
      SUMX=0.0
      SUMY=0.0
      SUMZ=0.0
      DO 410 N=1,NODE
      SUMX=SUMX+F(3*N-2)
      SUMY=SUMY+F(3*N-1)
      SUMZ=SUMZ+F(3*N)
      IF (ABS(F(3*N-2)).GT.XM1) XM1=ABS(F(3*N-2))
      IF (ABS(F(3*N-1)).GT.YM1) YM1=ABS(F(3*N-1))
  410 IF (ABS(F(3*N)).GT.ZM1) ZM1=ABS(F(3*N))
      DO 401 N=1,NODE                                                   
  401 WRITE(06,2405) N,NCB(1,N),NCB(2,N),NCB(3,N),F(3*N-2)              
     1   ,F(3*N-1),F(3*N),DU(1,N),DU(2,N),DU(3,N)                       
  403 WRITE(06,2406) IRR,LTSN,J9,LCOT,BW,BMX,BWW
      WRITE(06,2407) XM1,YM1,ZM1,SUMX,SUMY,SUMZ
      CLOSE(06,STATUS='KEEP')                                           
      CLOSE(05,STATUS='KEEP')                                           
 2404 FORMAT(/' NODE'/'   NO.  CONDITION X-Y-Z      ',                  
     1   'FORCE X-Y-Z',22X,'DISPLACEMENT X-Y-Z')                        
 2405 FORMAT(1H ,I5,I3,2I2,3F14.3,3E16.7)
 2406 FORMAT(/'  IRR =',I6,'    COEFFICIENT MATRIX     ',               
     1   '  COMPONENT =',I9/' ',16X,'SOLVER U MATRIX   ',               
     2   '   :   LINE =',I5,'   COMPONENT =',I9/' ',16X,                
     3   'RESIDUAL IN SOLUTION :  RESIDUAL NORM   =',F15.7                
     4   /' ',40X,'RIGHT SIDE NORM =',F15.7/' ',40X,                      
     5   'RES.N./RIG.N.   =',E15.6)                    
 2407 FORMAT(' ',16X,'NODAL FORCE NORM    X,Y,Z =',3F15.3
     1      /' ',16X,'NODAL FORCE BALANCE X,Y,Z =',3F15.3)
      STOP                                                              
      END                                                               
      SUBROUTINE GGG
      IMPLICIT REAL*8(A-H,O-Z)                         
      COMMON /A/RN22(20),H22(3,20),XYZ(3,20),DET,GZ,EA,
     1          ZE,H(3,20,5,5,5),BMA(6,60),M,LX,LY,LZ,IRR
      GZP=1.0+GZ                                                        
      EAP=1.0+EA                                                        
      ZEP=1.0+ZE                                                        
      GZM=1.0-GZ                                                        
      EAM=1.0-EA                                                        
      ZEM=1.0-ZE                                                        
      GZ2=1.0-GZ*GZ                                                     
      EA2=1.0-EA*EA                                                     
      ZE2=1.0-ZE*ZE                                                     
      RN22(1)=GZM*EAM*ZEM*(-GZ-EA-ZE-2.0)/8.0                           
      RN22(2)=GZP*EAM*ZEM*( GZ-EA-ZE-2.0)/8.0                           
      RN22(3)=GZP*EAP*ZEM*( GZ+EA-ZE-2.0)/8.0                           
      RN22(4)=GZM*EAP*ZEM*(-GZ+EA-ZE-2.0)/8.0                           
      RN22(5)=GZM*EAM*ZEP*(-GZ-EA+ZE-2.0)/8.0                           
      RN22(6)=GZP*EAM*ZEP*( GZ-EA+ZE-2.0)/8.0                           
      RN22(7)=GZP*EAP*ZEP*( GZ+EA+ZE-2.0)/8.0                           
      RN22(8)=GZM*EAP*ZEP*(-GZ+EA+ZE-2.0)/8.0                           
      RN22( 9)=GZ2*EAM*ZEM/4.0                                          
      RN22(10)=GZP*EA2*ZEM/4.0                                          
      RN22(11)=GZ2*EAP*ZEM/4.0                                          
      RN22(12)=GZM*EA2*ZEM/4.0                                          
      RN22(13)=GZM*EAM*ZE2/4.0                                          
      RN22(14)=GZP*EAM*ZE2/4.0                                          
      RN22(15)=GZP*EAP*ZE2/4.0                                          
      RN22(16)=GZM*EAP*ZE2/4.0                                          
      RN22(17)=GZ2*EAM*ZEP/4.0                                          
      RN22(18)=GZP*EA2*ZEP/4.0                                          
      RN22(19)=GZ2*EAP*ZEP/4.0                                          
      RN22(20)=GZM*EA2*ZEP/4.0                                          
      H22(1,1)=-EAM*ZEM*(-2.0*GZ-EA-ZE-1.0)/8.0                         
      H22(1,2)=EAM*ZEM*(2.0*GZ-EA-ZE-1.0)/8.0                           
      H22(1,3)=EAP*ZEM*(2.0*GZ+EA-ZE-1.0)/8.0                           
      H22(1,4)=-EAP*ZEM*(-2.0*GZ+EA-ZE-1.0)/8.0                         
      H22(1,5)=-EAM*ZEP*(-2.0*GZ-EA+ZE-1.0)/8.0                         
      H22(1,6)=EAM*ZEP*(2.0*GZ-EA+ZE-1.0)/8.0                           
      H22(1,7)=EAP*ZEP*(2.0*GZ+EA+ZE-1.0)/8.0                           
      H22(1,8)=-EAP*ZEP*(-2.0*GZ+EA+ZE-1.0)/8.0                         
      H22(1, 9)=-0.5*GZ*EAM*ZEM                                         
      H22(1,10)=EA2*ZEM/4.0                                             
      H22(1,11)=-0.5*GZ*EAP*ZEM                                         
      H22(1,12)=-EA2*ZEM/4.0                                            
      H22(1,13)=-EAM*ZE2/4.0                                            
      H22(1,14)=EAM*ZE2/4.0                                             
      H22(1,15)=EAP*ZE2/4.0                                             
      H22(1,16)=-EAP*ZE2/4.0                                            
      H22(1,17)=-0.5*GZ*EAM*ZEP                                         
      H22(1,18)=EA2*ZEP/4.0                                             
      H22(1,19)=-0.5*GZ*EAP*ZEP                                         
      H22(1,20)=-EA2*ZEP/4.0                                            
      H22(2,1)=-GZM*ZEM*(-GZ-2.0*EA-ZE-1.0)/8.0                         
      H22(2,2)=-GZP*ZEM*(GZ-2.0*EA-ZE-1.0)/8.0                          
      H22(2,3)=GZP*ZEM*(GZ+2.0*EA-ZE-1.0)/8.0                           
      H22(2,4)=GZM*ZEM*(-GZ+2.0*EA-ZE-1.0)/8.0                          
      H22(2,5)=-GZM*ZEP*(-GZ-2.0*EA+ZE-1.0)/8.0                         
      H22(2,6)=-GZP*ZEP*(GZ-2.0*EA+ZE-1.0)/8.0                          
      H22(2,7)=GZP*ZEP*(GZ+2.0*EA+ZE-1.0)/8.0                           
      H22(2,8)=GZM*ZEP*(-GZ+2.0*EA+ZE-1.0)/8.0                          
      H22(2, 9)=-GZ2*ZEM/4.0                                            
      H22(2,10)=-0.5*GZP*EA*ZEM                                         
      H22(2,11)=GZ2*ZEM/4.0                                             
      H22(2,12)=-0.5*GZM*EA*ZEM                                         
      H22(2,13)=-GZM*ZE2/4.0                                            
      H22(2,14)=-GZP*ZE2/4.0                                            
      H22(2,15)=GZP*ZE2/4.0                                             
      H22(2,16)=GZM*ZE2/4.0                                             
      H22(2,17)=-GZ2*ZEP/4.0                                            
      H22(2,18)=-0.5*GZP*EA*ZEP                                         
      H22(2,19)=GZ2*ZEP/4.0                                             
      H22(2,20)=-0.5*GZM*EA*ZEP                                         
      H22(3,1)=-GZM*EAM*(-2.0*ZE-GZ-EA-1.0)/8.0                         
      H22(3,2)=-GZP*EAM*(-2.0*ZE+GZ-EA-1.0)/8.0                         
      H22(3,3)=-GZP*EAP*(-2.0*ZE+GZ+EA-1.0)/8.0                         
      H22(3,4)=-GZM*EAP*(-2.0*ZE-GZ+EA-1.0)/8.0                         
      H22(3,5)=GZM*EAM*(2.0*ZE-GZ-EA-1.0)/8.0                           
      H22(3,6)=GZP*EAM*(2.0*ZE+GZ-EA-1.0)/8.0                           
      H22(3,7)=GZP*EAP*(2.0*ZE+GZ+EA-1.0)/8.0                           
      H22(3,8)=GZM*EAP*(2.0*ZE-GZ+EA-1.0)/8.0                           
      H22(3, 9)=-GZ2*EAM/4.0                                            
      H22(3,10)=-GZP*EA2/4.0                                            
      H22(3,11)=-GZ2*EAP/4.0                                            
      H22(3,12)=-GZM*EA2/4.0                                            
      H22(3,13)=-0.5*GZM*EAM*ZE                                         
      H22(3,14)=-0.5*GZP*EAM*ZE                                         
      H22(3,15)=-0.5*GZP*EAP*ZE                                         
      H22(3,16)=-0.5*GZM*EAP*ZE                                         
      H22(3,17)=GZ2*EAM/4.0                                             
      H22(3,18)=GZP*EA2/4.0                                             
      H22(3,19)=GZ2*EAP/4.0                                             
      H22(3,20)=GZM*EA2/4.0                                             
      RETURN                                                            
      END                                                               
      SUBROUTINE FFF                                                    
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(20),H22(3,20),XYZ(3,20),DET,GZ,EA,
     1          ZE,H(3,20,5,5,5),BMA(6,60),M,LX,LY,LZ,IRR
      DIMENSION GJI(3,3),GH(3,20),GJ(3,3)                               
      DO 500 I=1,3                                                      
      DO 500 J=1,3                                                      
      GJ(I,J)=0.0                                                       
      DO 500 K=1,20                                                     
  500 GJ(I,J)=GJ(I,J)+H(I,K,LX,LY,LZ)*XYZ(J,K)                          
      DET=GJ(1,1)*GJ(2,2)*GJ(3,3)+GJ(1,2)*GJ(2,3)*GJ(3,1)               
     1   +GJ(1,3)*GJ(2,1)*GJ(3,2)-GJ(1,3)*GJ(2,2)*GJ(3,1)               
     2   -GJ(1,2)*GJ(2,1)*GJ(3,3)-GJ(1,1)*GJ(2,3)*GJ(3,2)               
      IF(ABS(DET).GT.1.E-09) GO TO 501                                  
      IRR=40000+M                                                       
      RETURN                                                            
  501 GJI(1,1)=( GJ(2,2)*GJ(3,3)-GJ(2,3)*GJ(3,2))/DET                   
      GJI(2,1)=(-GJ(2,1)*GJ(3,3)+GJ(2,3)*GJ(3,1))/DET                   
      GJI(3,1)=( GJ(2,1)*GJ(3,2)-GJ(2,2)*GJ(3,1))/DET                   
      GJI(1,2)=(-GJ(1,2)*GJ(3,3)+GJ(1,3)*GJ(3,2))/DET                   
      GJI(2,2)=( GJ(1,1)*GJ(3,3)-GJ(1,3)*GJ(3,1))/DET                   
      GJI(3,2)=(-GJ(1,1)*GJ(3,2)+GJ(1,2)*GJ(3,1))/DET                   
      GJI(1,3)=( GJ(1,2)*GJ(2,3)-GJ(1,3)*GJ(2,2))/DET                   
      GJI(2,3)=(-GJ(1,1)*GJ(2,3)+GJ(1,3)*GJ(2,1))/DET                   
      GJI(3,3)=( GJ(1,1)*GJ(2,2)-GJ(1,2)*GJ(2,1))/DET                   
      DO 502 I=1,20                                                     
      DO 502 J=1,3                                                      
      GH(J,I)=0.0                                                       
      DO 502 K=1,3                                                      
  502 GH(J,I)=GH(J,I)+GJI(J,K)*H(K,I,LX,LY,LZ)                          
      DO 503 I=1,6                                                      
      DO 503 J=1,60                                                     
  503 BMA(I,J)=0.0                                                      
      DO 504 J=1,20                                                     
      BMA(1,3*J-2)=GH(1,J)                                              
      BMA(2,3*J-1)=GH(2,J)                                              
      BMA(3,3*J)  =GH(3,J)                                              
      BMA(4,3*J-2)=GH(2,J)                                              
      BMA(4,3*J-1)=GH(1,J)                                              
      BMA(5,3*J-1)=GH(3,J)                                              
      BMA(5,3*J)  =GH(2,J)                                              
      BMA(6,3*J-2)=GH(3,J)                                              
  504 BMA(6,3*J)  =GH(1,J)                                              
      RETURN                                                            
      END                                                               
